<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: WS2812 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classWS2812-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">WS2812 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Driver for WS2812/NeoPixel data.  
 <a href="classWS2812.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="WS2812_8h_source.html">WS2812.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a873e567f57a612a0e408b5bb310d9024"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a873e567f57a612a0e408b5bb310d9024">WS2812</a> (gpio_num_t gpioNum, uint16_t pixelCount, int channel=RMT_CHANNEL_0)</td></tr>
<tr class="memdesc:a873e567f57a612a0e408b5bb310d9024"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a wrapper for the pixels.  <a href="#a873e567f57a612a0e408b5bb310d9024">More...</a><br /></td></tr>
<tr class="separator:a873e567f57a612a0e408b5bb310d9024"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad03797836617dccf530cb7c6423c03fe"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe">show</a> ()</td></tr>
<tr class="memdesc:ad03797836617dccf530cb7c6423c03fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Show the current Neopixel data.  <a href="#ad03797836617dccf530cb7c6423c03fe">More...</a><br /></td></tr>
<tr class="separator:ad03797836617dccf530cb7c6423c03fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a68e53534f4b1f68e447621caf0e2e6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a7a68e53534f4b1f68e447621caf0e2e6">setColorOrder</a> (char *order)</td></tr>
<tr class="memdesc:a7a68e53534f4b1f68e447621caf0e2e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the color order of data sent to the LEDs.  <a href="#a7a68e53534f4b1f68e447621caf0e2e6">More...</a><br /></td></tr>
<tr class="separator:a7a68e53534f4b1f68e447621caf0e2e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60025d23e7fc21c3ce8c1f02bd50bf86"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a60025d23e7fc21c3ce8c1f02bd50bf86">setPixel</a> (uint16_t index, uint8_t red, uint8_t green, uint8_t blue)</td></tr>
<tr class="memdesc:a60025d23e7fc21c3ce8c1f02bd50bf86"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the given pixel to the specified color.  <a href="#a60025d23e7fc21c3ce8c1f02bd50bf86">More...</a><br /></td></tr>
<tr class="separator:a60025d23e7fc21c3ce8c1f02bd50bf86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f37824dbf4730986d4ebde58c25a48d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a2f37824dbf4730986d4ebde58c25a48d">setPixel</a> (uint16_t index, <a class="el" href="structpixel__t.html">pixel_t</a> pixel)</td></tr>
<tr class="memdesc:a2f37824dbf4730986d4ebde58c25a48d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the given pixel to the specified color.  <a href="#a2f37824dbf4730986d4ebde58c25a48d">More...</a><br /></td></tr>
<tr class="separator:a2f37824dbf4730986d4ebde58c25a48d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65924d977bab621786b01a09c91456f6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a65924d977bab621786b01a09c91456f6">setPixel</a> (uint16_t index, uint32_t pixel)</td></tr>
<tr class="memdesc:a65924d977bab621786b01a09c91456f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the given pixel to the specified color.  <a href="#a65924d977bab621786b01a09c91456f6">More...</a><br /></td></tr>
<tr class="separator:a65924d977bab621786b01a09c91456f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab351cea856076c96121d5c3b64f2a7f3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#ab351cea856076c96121d5c3b64f2a7f3">setHSBPixel</a> (uint16_t index, uint16_t hue, uint8_t saturation, uint8_t brightness)</td></tr>
<tr class="memdesc:ab351cea856076c96121d5c3b64f2a7f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the given pixel to the specified HSB color.  <a href="#ab351cea856076c96121d5c3b64f2a7f3">More...</a><br /></td></tr>
<tr class="separator:ab351cea856076c96121d5c3b64f2a7f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aceeaba644d2cc545b84d2807732b6461"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#aceeaba644d2cc545b84d2807732b6461">clear</a> ()</td></tr>
<tr class="memdesc:aceeaba644d2cc545b84d2807732b6461"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all the pixel colors.  <a href="#aceeaba644d2cc545b84d2807732b6461">More...</a><br /></td></tr>
<tr class="separator:aceeaba644d2cc545b84d2807732b6461"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58973dedd9cbc5c3fd3397f07f9a720f"><td class="memItemLeft" align="right" valign="top"><a id="a58973dedd9cbc5c3fd3397f07f9a720f"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classWS2812.html#a58973dedd9cbc5c3fd3397f07f9a720f">~WS2812</a> ()</td></tr>
<tr class="memdesc:a58973dedd9cbc5c3fd3397f07f9a720f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class instance destructor. <br /></td></tr>
<tr class="separator:a58973dedd9cbc5c3fd3397f07f9a720f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Driver for WS2812/NeoPixel data. </p>
<p>NeoPixels or WS2812s are LED devices that can illuminate in arbitrary colors with 8 bits of data for each of the red, green and blue channels. These devices can be daisy chained together to produce a string of LEDs. If we call each LED instance a pixel, then when we want to set the value of a string of pixels, we need to supply the data for all the pixels. This class encapsulates setting the color value for an individual pixel within the string and, once you have set up all the desired colors, you can then set all the pixels in a <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a> operation. The class hides from you the underlying details needed to drive the devices.</p>
<div class="fragment"><div class="line"><a class="code" href="classWS2812.html">WS2812</a> ws2812 = <a class="code" href="classWS2812.html#a873e567f57a612a0e408b5bb310d9024">WS2812</a>(</div><div class="line">  16, <span class="comment">// Pin</span></div><div class="line">  8   <span class="comment">// Pixel count</span></div><div class="line">);</div><div class="line">ws2812.<a class="code" href="classWS2812.html#a60025d23e7fc21c3ce8c1f02bd50bf86">setPixel</a>(0, 128, 0, 0);</div><div class="line">ws2812.<a class="code" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe">show</a>();</div></div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a873e567f57a612a0e408b5bb310d9024"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a873e567f57a612a0e408b5bb310d9024">&#9670;&nbsp;</a></span>WS2812()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">WS2812::WS2812 </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>dinPin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>pixelCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>channel</em> = <code>RMT_CHANNEL_0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a wrapper for the pixels. </p>
<p>In order to drive the NeoPixels we need to supply some basic information. This includes the GPIO pin that is connected to the data-in (DIN) of the devices. Since we also want to be able to drive a string of pixels, we need to tell the class how many pixels are present in the string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">dinPin</td><td>The GPIO pin used to drive the data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pixelCount</td><td>The number of pixels in the strand. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">channel</td><td>The <a class="el" href="classRMT.html" title="Drive the RMT peripheral.">RMT</a> channel to use. Defaults to RMT_CHANNEL_0. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aceeaba644d2cc545b84d2807732b6461"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aceeaba644d2cc545b84d2807732b6461">&#9670;&nbsp;</a></span>clear()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::clear </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Clear all the pixel colors. </p>
<p>This sets all the pixels to off which is no brightness for all of the color channels. The LEDs are not actually updated until a call to <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a>. </p>

</div>
</div>
<a id="a7a68e53534f4b1f68e447621caf0e2e6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a68e53534f4b1f68e447621caf0e2e6">&#9670;&nbsp;</a></span>setColorOrder()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::setColorOrder </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>colorOrder</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the color order of data sent to the LEDs. </p>
<p>Data is sent to the WS2812s in a serial fashion. There are 8 bits of data for each of the three channel colors (red, green and blue). The <a class="el" href="classWS2812.html" title="Driver for WS2812/NeoPixel data.">WS2812</a> LEDs typically expect the data to arrive in the order of "green" then "red" then "blue". However, this has been found to vary between some models and manufacturers. What this means is that some want "red", "green", "blue" and still others have their own orders. This function can be called to override the default ordering of "GRB". We can specify an alternate order by supply an alternate three character string made up of 'R', 'G' and 'B' for example "RGB". </p>

</div>
</div>
<a id="ab351cea856076c96121d5c3b64f2a7f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab351cea856076c96121d5c3b64f2a7f3">&#9670;&nbsp;</a></span>setHSBPixel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::setHSBPixel </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>hue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>saturation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>brightness</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the given pixel to the specified HSB color. </p>
<p>The LEDs are not actually updated until a call to <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">index</td><td>The pixel that is to have its color set. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">hue</td><td>The amount of hue in the pixel (0-360). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">saturation</td><td>The amount of saturation in the pixel (0-255). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">brightness</td><td>The amount of brightness in the pixel (0-255). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a60025d23e7fc21c3ce8c1f02bd50bf86"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a60025d23e7fc21c3ce8c1f02bd50bf86">&#9670;&nbsp;</a></span>setPixel() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::setPixel </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>red</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>green</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>blue</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the given pixel to the specified color. </p>
<p>The LEDs are not actually updated until a call to <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">index</td><td>The pixel that is to have its color set. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">red</td><td>The amount of red in the pixel. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">green</td><td>The amount of green in the pixel. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blue</td><td>The amount of blue in the pixel. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2f37824dbf4730986d4ebde58c25a48d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2f37824dbf4730986d4ebde58c25a48d">&#9670;&nbsp;</a></span>setPixel() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::setPixel </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structpixel__t.html">pixel_t</a>&#160;</td>
          <td class="paramname"><em>pixel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the given pixel to the specified color. </p>
<p>The LEDs are not actually updated until a call to <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">index</td><td>The pixel that is to have its color set. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pixel</td><td>The color value of the pixel. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a65924d977bab621786b01a09c91456f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65924d977bab621786b01a09c91456f6">&#9670;&nbsp;</a></span>setPixel() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::setPixel </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>pixel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the given pixel to the specified color. </p>
<p>The LEDs are not actually updated until a call to <a class="el" href="classWS2812.html#ad03797836617dccf530cb7c6423c03fe" title="Show the current Neopixel data.">show()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">index</td><td>The pixel that is to have its color set. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pixel</td><td>The color value of the pixel. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad03797836617dccf530cb7c6423c03fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad03797836617dccf530cb7c6423c03fe">&#9670;&nbsp;</a></span>show()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void WS2812::show </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Show the current Neopixel data. </p>
<p>Drive the LEDs with the values that were previously set. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="WS2812_8h_source.html">WS2812.h</a></li>
<li>WS2812.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
